Subject: hpff-doc: Comments on overview.tex

From: Piyush Mehrotra <[email-masked]>
Date: Tue, 15 Oct 1996 10:15:09 -0400 (EDT)

---------------------------------------------------------------------------
[email-masked] is a mailing list for HPF 2.0 language specification
authors and editors.  Instructions for adding or deleting yourself from this
list appear at the bottom of this message.
---------------------------------------------------------------------------

I am suggesting several changes below. Some of these are just that i.e.
suggestions of style changes etc. However some are real errors and need to
be fixed.  Some of these may have been pointed out by others already. 

	- Piyush

Page 4 Line 18:
Reference to Fortran 95 standard needs to be added

Page 4 Line 48:
Replace 
	FORALL construct
with 
	FORALL statement and construct

Page 6 Line 27:

Is the use of a comma correct Fortran 95 FORALL or should it be a
semicolon?

Page 8 Line 38:
Replace
	likely in initial compiler implementations.
with
	likely to be supported in initial compiler implementations.

Page 8 Line 41
Replace Section Header
    \subsubsection*{Data Distribution Features (Section~\ref{ch-mapping-base})}

with
    \subsubsection*{Data Distribution Features (Sections~\ref{ch-mapping-base}
    and~\ref{ch-mapping-subr})}

Page 9 Lines 5 & 6
Replace
    Section~\ref{ch-mapping-subr} describes certain restrictions and directives
    related to storage and sequence association.
with
    Restrictions and directives
    related to storage and sequence association are described in
    Sections~\ref{ch-mapping-subr} and~\ref{ch-mapping-subr}.

Page 10 Line 2:
Replace
    The extended features facilitate explicit computation partitioning
    through use of the {\tt ON} directive. 
with
    The {\tt ON} directive facilitates explicit computation partitioning.

Page 10 Lines 5 -10:
Change order of RESIDENT and TASK_REGION, i.e. replace
    The {\tt TASK\_REGION}
    directive allows the user to specify the concurrent execution of
    different blocks of code on disjoint processor subsets.
    In order to assist the compiler in
    generating efficient code, the {\tt RESIDENT} directive is defined, to be
    used in conjunction with an {\tt ON} directive by the programmer. It can
    be used to assert that all accesses to the specified variable
    within the scope of the {\tt ON} directive are to be found locally
    on the executing processor.
with
    In order to assist the compiler in
    generating efficient code, the {\tt RESIDENT} directive is defined, to be
    used in conjunction with an {\tt ON} directive by the programmer. It can
    be used to assert that all accesses to the specified variable
    within the scope of the {\tt ON} directive are to be found locally
    on the executing processor.
    The {\tt TASK\_REGION}
    directive allows the user to specify the concurrent execution of
    different blocks of code on disjoint processor subsets.

Page 10 Lines 15-17:
Change order of Wait and I/O Control parameter, i.e. replace 
    This is done through a new statement ({\tt WAIT}) and an
    additional I/O control parameter in the Fortran {\tt READ/WRITE} statement
    that specifies non-blocking execution.
with
    This is done through an additional I/O control parameter in the Fortran 
    {\tt READ/WRITE} statement that specifies non-blocking execution and
    a new statement ({\tt WAIT}).

Page 10 Line 33
Replace:
    Additional extrinsic interfaces are
    included in Annex~\ref{ch-extrinsic-app}, that are formally recognized by
    HPFF, but not defined and maintained by HPFF.
with
    Additional extrinsic interfaces that are formally recognized by
    the HPF Forum, but not defined and maintained by the Forum 
    are included in Annexes~\ref{ch-hpf-craft} and~\ref{ch-f77-local-library-app}. 

Page 10 - 11:
In Section 1.4 "Changes from HPF 1.1"

Should the (boldfaced) headers as detailed in the first part of the
subsection be the same as those used later in presenting the details?

Page 11 Line 17-18:
Replace:
    Finally, the document
    acknowledges a category HPF-related Extrinsic interfaces
with
    Finally, the document
    acknowledges a new category, HPF-related Extrinsic interfaces,

Page 11 Line 22:
Replace:
     Each of these categories is summarized in the following Sections.
with
     Each of these categories is summarized in the following subsections.

Page 11-13:
Replace all subsubsection with subsection.

Page 11 Lines 28-31:
Replace:
    \item The {\tt FORALL} statement and construct
    \item The {\tt PURE} attribute for procedures
with
    \item The {\tt FORALL} statement and construct;
    \item The {\tt PURE} attribute for procedures;

Page 11 Lines 37-40:
Replace:
    \item In any procedure call in which distributed data may require
    redistribution, the  procedure must now have an explicit interface.
    \item Sequential arrays may no longer be explicitly mapped
with
    \item Sequential arrays may no longer be explicitly mapped;
    \item In any procedure call in which distributed data may require
    redistribution, the  procedure must now have an explicit interface;

Page 12 Lines 4-6:
Replace:
    \item The {\tt REDUCTION} clause for  {\tt INDEPENDENT} loops.
    \item The new HPF_LIBRARY procedures {\tt SORT_DOWN, SORT_UP}
with
    \item The {\tt REDUCTION} clause for  {\tt INDEPENDENT} loops;
    \item The new HPF_LIBRARY procedures {\tt SORT_DOWN, SORT_UP}.

Page 12 Section 14.0.5:
Do we need to provide such detail in this section. We have already
provided a summary of new features in Section 1.3?

Page 12 Lines 10:
Replace:
    The Approved Extensions include the following features not part of HPF
    1.1
with
    The Approved Extensions include the following features not part of HPF
    1.1:

The next few changes are to get consistency across all the items. Some
items have introduced with full sentences while others with phrases.

Page 12 Lines 19-21:
Replace:
    \item The {\tt GEN_BLOCK} and {\tt INDIRECT} distributions. ...
with
    \item New distributions, {\tt GEN_BLOCK} and {\tt INDIRECT} have been 
	added.

Page 12 Lines 22-24:
Replace:
    \item The {\tt RANGE} directive provides additional information to the 
    compiler
    on {\tt DYNAMIC} variables or transcriptive dummy arguments, and may allow 
    for
    improved  efficiency.
with
    \item The {\tt RANGE} directive provides additional information to the 
    compiler on {\tt DYNAMIC} variables, transcriptive dummy arguments
    or pointers, and may allow for improved  efficiency.

Page 12 Lines 28-30:
Replace:
    \item The {\tt ON} directive  provides advice to the
    compiler on where  best to carry out a computation.
with
    \item The {\tt ON} directive  provides advice to the
    compiler on where  best to carry out a computation.
    This also introduces the concept of {\it active processor sets},
    the currently active subset of processors.

Page 12 Lines 39-40:
Replace:
    \item Additional intrinsic procedures {\tt ACTIVE_NUM_PROCS} and  {\tt
    ACTIVE_PROCS_SHAPE}, and a generalized {\tt TRANSPOSE} intrinsic.
with
    \item Additional intrinsic procedures {\tt ACTIVE_NUM_PROCS} and  {\tt
    ACTIVE_PROCS_SHAPE}, and a generalized {\tt TRANSPOSE} intrinsic
    have been introduced.

Page 12 Lines 42-43
Replace:
    \item New and revised {\tt HPF_LIBRARY} procedures {\tt HPF_ALIGNMENT,
    HPF_DISTRIBUTION, HPF_TEMPLATE, HPF_MAP_ARRAY,  HPF_NUMBER_MAPPED}.
with
    \item The {\tt HPF_LIBRARY} procedures {\tt HPF_ALIGNMENT,
    HPF_DISTRIBUTION} and {\tt  HPF_TEMPLATE} have been revised
    and new procedures {\tt HPF_MAP_ARRAY} and {\tt  HPF_NUMBER_MAPPED}
    have been added.

Page 12 Line 45:
Replace:
    \item Facilities for asynchronous input/output.
with
    \item An additional I/O control parameter in the Fortran {\tt READ/WRITE} 
    statement and a new statement, {\tt WAIT}, facilitates
    asynchronous input/output.

Page 12 Line 47-48:
Replace:
    \item Extensions to the {\tt EXTRINSIC} facilities defined in HPF 2.0 to
    support interoperability with C and FORTRAN 77.
with
    \item Extensions to the {\tt EXTRINSIC} facilities defined in HPF 2.0 
    provide support for interoperability with C and FORTRAN 77.

Page 13 Line 7-8:
Replace:
    HPFF
with
    the HPF Forum.

Page 14: Line 23-24
Replace:
    executable-directive   \IS   realign-directive
			   \OR   redistribute-directive
			   \OR   independent-directive
with
    executable-directive   \IS  independent-directive

Page 15: Line 33-35
Replace:
    executable-directive-extended \IS  independent-directive
			   \OR realign-directive
			   \OR   redistribute-directive
with
    executable-directive-extended \IS  realign-directive
			   \OR   redistribute-directive

---------------------------------------------------------------------------
To (un)subscribe to this list, send mail to [email-masked].
Leave the subject line blank, and in the body put the line
(un)subscribe <email-address>
---------------------------------------------------------------------------